use std::sync::{Arc, Mutex};
use std::thread;
use std::env;

fn fibonacci(n: i32) -> i32 {
	if n == 0 {
		return 0;
	}
	if n <= 1 {
		return 1;
	}
    else {
		return fibonacci(n - 1) + fibonacci(n - 2);
	}
}

fn main() {
    let args: Vec<_> = env::args().collect();
	if args.len() != 2 {
 		println!("Usage: {} n", args[0]);
        return;
 	}

	let n: i32;
	let m = &args[1];
    match m.parse::<i32>() {
      Ok(n1) => n = n1,
      Err(e) => panic!("{} is NOT a number!", e),
    }
	println!("Going to create {} threads!", n);

	let sum = Arc::new(Mutex::new(0));
	let mut threads_vec = vec![];
	
	for i in 0..n {
		let sum = sum.clone();
	    let t = thread::spawn(move || {
	        let mut total = sum.lock().unwrap();
	        *total += fibonacci(i);
	    });
		threads_vec.push(t);
	}

	for thread in threads_vec {
		thread.join().unwrap();
	}
	println!("Summary: {}", *sum.lock().unwrap());
}
