use std::fs;
use std::thread;
use std::env;

struct Filename {
    file_path: String,
}

impl Drop for Filename {
    fn drop(&mut self) {
        if thread::panicking() {
            println!("thread::panicking()!");
        } else {
            println!("No thread::panicking()!");
        }
    }
}

fn delete_file(file_struct: Filename) -> thread::Result<()> {
    thread::spawn(move || {
        fs::remove_file(&file_struct.file_path).expect("Error in deleting!");
    }).join()
}

fn main() {
    let args: Vec<_> = env::args().collect();
    if args.len() == 1 {
        println!("Need one argument.");
        std::process::exit(-1);
    }
    let my_file_path = std::env::args().nth(1).unwrap();

    let filepath = Filename {
        file_path: my_file_path.into(),
    };

    match delete_file(filepath) {
        Ok(_) => println!("File deleted!"),
        Err(_) => println!("Failed to delete file!"),
    }
}
