use std::sync::mpsc;
use std::thread;
use std::time::Duration;

fn main() {
    let (t, r) = mpsc::channel();

    thread::spawn(move || {
        let val = String::from("Hi from LXF");
        t.send(val).unwrap();
    });

    let received = r.recv().unwrap();
    println!("Got: {}", received);

    // Now send multiple messages
    let (tx, rx) = mpsc::channel();

    let messages = vec![
        String::from("Linux Format"),
        String::from("is the best"),
        String::from("Linux Magazine!"),
    ];

    thread::spawn(move || {
        for message in messages {
            tx.send(message).unwrap();
            thread::sleep(Duration::from_secs(1));
        }
    });

    for received in rx {
        println!("Got: {}", received);
    }
}
